| Apache Ignite C++

Public Types | List of all members
ignite::transactions::TransactionIsolation Struct Reference

Defines different cache transaction isolation levels. More...

`#include <transaction_consts.h>`

## Public Types
enum | Type { READ_COMMITTED = 0, REPEATABLE_READ = 1, SERIALIZABLE = 2 }

## Detailed Description

Defines different cache transaction isolation levels.

## Member Enumeration Documentation

## ◆ Type

enum ignite::transactions::TransactionIsolation::Type

Enumerator
READ_COMMITTED | Read committed isolation level. This isolation level means that always a committed value will be provided for read operations. With this isolation level values are always read from cache global memory or persistent store every time a value is accessed. In other words, if the same key is accessed more than once within the same transaction, it may have different value every time since global cache memory may be updated concurrently by other threads.
REPEATABLE_READ | Repeatable read isolation level. This isolation level means that if a value was read once within transaction, then all consecutive reads will provide the same in-transaction value. With this isolation level accessed values are stored within in-transaction memory, so consecutive access to the same key within the same transaction will always return the value that was previously read or updated within this transaction. If concurrency is ::IGNITE_TX_CONCURRENCY_PESSIMISTIC, then a lock on the key will be acquired prior to accessing the value.
SERIALIZABLE | Serializable isolation level. This isolation level means that all transactions occur in a completely isolated fashion, as if all transactions in the system had executed serially, one after the other. Read access with this level happens the same way as with ::IGNITE_TX_ISOLATION_REPEATABLE_READ level. However, in ::IGNITE_TX_CONCURRENCY_OPTIMISTIC mode, if some transactions cannot be serially isolated from each other, then one winner will be picked and the other transactions in conflict will result in IgniteError being thrown.

The documentation for this struct was generated from the following file:

- core/include/ignite/transactions/transaction_consts.h